##############################################################################
#
#  			Copyright 2003 MPIMG Berlin, Germany.
#			      All Rights Reserved
#
#
#  System        : 
#  Module        : 
#  Object Name   : $RCSfile$
#  Revision      : $Revision$
#  Date          : $Date$
#  Author        : $Author$
#  Created By    : Dr. Detlef Groth
#  Created       : Mon Mar 10 16:41:10 2003
#  Last Modified : <031001.1609>
#
#  Description	
#
#  Notes
#
#  History
#	
#  $Log$
#
##############################################################################
#
#  Copyright (c) 2003 MPIMG Berlin, Germany.
# 
#  All Rights Reserved.
# 
#  This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
#  reproduced,  translated,  or  reduced to any  electronic  medium or machine
#  readable form without prior written consent from MPIMG Berlin, Germany.
#
##############################################################################

proc PannedTop {f side args} {
    frame $f
    pack [PanedWindow $f.pw -side left -pad 0] -fill both -expand true
    set x 0
    lappend widgets $f.pw
    foreach el $args {
        set pane [$f.pw add -weight 1]
        if { $el ne "frame" } {
            set w [Scrolled $pane.f $el]
        }
        lappend widgets $w
        incr x
    }
    pack $f -side top -fill both -expand true
    return $widgets
   
}
proc Paned {pan side args} {
    if {$side eq "vertical"} {
        pack [panedwindow $pan -orient $side -sashwidth 4] -side top -expand yes -fill both -pady 2 -padx 2
    } else {
        pack [panedwindow $pan -orient $side -sashwidth 4] -side left -expand yes -fill both -pady 2 -padx 2
        
    }
    set x 0
    lappend widgets $pan
    foreach el $args {
        if {$el ne "frame"} {
            set w [Scrolled $pan.f$x $el]
        } else {
            pack [frame $pan.f$x] -side top -fill both -expand yes
            set w $pan.f$x
        }
        if {$side eq "vertical"} {
            $pan.f$x configure -height 100
        } else {
            $pan.f$x configure -width 100
        }
        lappend widgets $w
        $pan add $pan.f$x
        incr x
    }
    pack $pan
    return $widgets
    
}
proc PannedBW {f side args} {
    frame $f
    pack [PanedWindow $f.pw -side $side -pad 0] -fill both -expand true
    set x 0
    lappend widgets $f.pw
    foreach el $args {
        set pane [$f.pw add -weight 1]
        if { $el ne "frame" } {
            set w [Scrolled $pane.f $el]
        } else {
            pack [frame $pane.fr] -side top -fill both -expand yes
            set w $pane.fr
        }
        lappend widgets $w
        incr x
    }
    pack $f -side top -fill both -expand true
    return $widgets
   
}

proc Scrolled {f widget args} {
    if {![winfo exists $f]} {
        frame $f
    }
    # The setgrid setting allows the window to be resized.
    eval { $widget $f.text -xscrollcommand [list $f.xscroll set] \
              -yscrollcommand [list $f.yscroll set]  } $args
   
    scrollbar $f.xscroll -orient horizontal  -command [list $f.text xview]
    scrollbar $f.yscroll -orient vertical  -command [list $f.text yview]
    pack $f.xscroll -side bottom -fill x
    pack $f.yscroll -side right -fill y
    # The fill and expand are needed when resizing.
    pack $f.text -side left -fill both -expand true
    pack $f -side top -fill both -expand true
    return $f.text
}
proc ScrolledY {f widget args} {
    frame $f
    # The setgrid setting allows the window to be resized.
    eval { $widget $f.text \
              -yscrollcommand [list $f.yscroll set]  } $args
   
    scrollbar $f.yscroll -orient vertical  -command [list $f.text yview]
    pack $f.yscroll -side right -fill y
    # The fill and expand are needed when resizing.
    pack $f.text -side left -fill both -expand true
    pack $f -side top -fill both -expand true
    return $f.text
}
proc iincr { varName {amount 1}} {
    # improved incr which also incr non existing vars
    upvar 1 $varName var
    if {[info exists var]} {
        set var [expr $var + $amount]
    } else {
        set var $amount
    }
    return $var
}
proc ldelete { list args } {
    foreach i $args {
        # deleting a item by value
        set ix [lsearch -exact $list $i]
        if {$ix >= 0} {
            set list [lreplace $list $ix $ix]
        } 
    }
    return $list
}
proc lintersect { list1 list2 } {
    set intersection {}

    foreach element $list1 {
        set flag($element) {}
    }
    
    foreach element $list2 {
        if {[info exists flag($element)]} {
            lappend intersection $element
        }
    }
    
    return $intersection
}
proc luniq {myList} {
    foreach elem $myList {
        set temp($elem) 1
    }
    set newList [list]
    foreach elem [lsort -dictionary [array names temp]] {
        lappend newList $elem
    } 
    return $newList
}
proc getBoolean { string } {
    if { $string eq false } {
        return false
    } elseif { $string eq no } {
        return false
    } elseif { $string eq "0" } {
        return false
    } elseif { [string length $string] > 1 } {
        return true
    } else {
        return true
    }
}
proc push { stack value } {
	upvar $stack S
	if {![info exists S(top)]} {
		set S(top) 0
	}
	set S($S(top)) $value
	incr S(top)
}
proc pop { stack } {
	upvar $stack S
	if {![info exists S(top)]} {
		return {}
	}
	if {$S(top) == 0} {
		return {}
	} else {
		incr S(top) -1
		set x $S($S(top))
		unset S($S(top))
		return $x
	}
    }
    
# sleep implementation

# Will suspend evaluation of current code block, but allow the event loop to
# continue handling pending events.

# This particular version of uniqkey is my favorite because the keys generated
# will generally sort in time created order.

 proc uniqkey { } {
     set key   [ expr { pow(2,31) + [ clock clicks ] } ]
     set key   [ string range $key end-8 end-3 ]
     set key   [ clock seconds ]$key
     return $key
 }

 proc sleep { ms } {
     set uniq [ uniqkey ]
     set ::__sleep__tmp__$uniq 0
     after $ms set ::__sleep__tmp__$uniq 1
     vwait ::__sleep__tmp__$uniq
     unset ::__sleep__tmp__$uniq
 }
 
 proc busy {args} {
    foreach el $args {
        $el configure -cursor watch
    }
    update 
    update idletasks
}
proc unbusy {args} {
    foreach el $args {
        $el configure -cursor arrow
    }
}
proc File:CountLines {filename} {
    set lines 0
    if [catch {open $filename r} infh] {
        puts stderr "Cannot open $filename: $infh"
        exit
    } else {
        while {[gets $infh line] >= 0} {
            incr lines
            
        }
        close $infh
        
    }
    return $lines
}
proc File:GetLines {filename start end} {
    set x -1
    set text ""
    if [catch {open $filename r} infh] {
        tk_messageBox -title "Info!" -icon info -message "Cannot open $filename: $infh" -type ok
     
    } else {
        while {[gets $infh line] >= 0} {
            incr x
            if {$x < $start} {continue}
            append text "$line\n"
           
            if {$x >= $end} { break }
           
            
            
        }
        close $infh
    } 
    return $text
}
proc Socket:Client:SendFile {name host port} {
    set size [file size $name] 
    set fp [open $name] 
    fconfigure $fp -translation binary 
    set channel  [socket $::host $::port] 
    fconfigure $channel -translation  binary 
    puts $channel [list $name $size] 
    fcopy $fp $channel -size $size 
    close  $fp 
    close $channel
}
proc Socket:Server:GetFile {channel_name client_address client_port} {
    # use it with
    # socket -server Socket:Server:GetFile portnumber
    # vwait forever
    fconfigure $channel_name -translation binary
    gets $channel_name line
    foreach {name size} $line {}
    puts stderr "getting $name"
    set fully_qualified_filename [file join $::destination_directory $name]
    set fp [open $fully_qualified_filename w]
    fconfigure $fp -translation binary
    fcopy $channel_name $fp -size $size
    close $channel_name
    close $fp
}
proc help {key} {
   global var argv0
   if { [winfo exists .help] } {
         wm deiconify .help
         Wikit::ShowPage $key
   } else {
       set docdir [file join  .. doc]
       if { [info exist var(starkit)] } {
           set docdir "$argv0/doc"
       } 
       toplevel .help ; 
       if [string match *kit $argv0] {
           Wikit::init [file join $starkit::topdir doc $var(appname).tkd] 1 .help
           #tk_messageBox -title "Info!" -icon info -message "$argv0 [file join [info script] doc $var(appname).tkd]" -type ok
       } elseif [string match *exe/main.tcl $argv0] {
           #tk_messageBox -title "Info!" -icon info -message "$argv0 [file join [file dirname $argv0] doc $var(appname).tkd]]"
           Wikit::init [file join $starkit::topdir doc $var(appname).tkd] 1 .help
       } else {
            Wikit::init [file join $starkit::topdir doc $var(appname).tkd] 1 .help
       }
       #Wikit::init  1 .help
       Wikit::ShowPage $key
   }   
}
proc LabelCombo {frame label pack} {
    pack [frame $frame] -side $pack -fill x -expand no
    pack [label $frame.lbl -text $label] -side left -expand no
    pack [ComboBox $frame.combo] -side left -expand no -fill x
    lappend widgets $frame 
    lappend widgets $frame.lbl
    lappend widgets $frame.combo
    return $widgets
    
}
proc Debug {msg} {
    global var
    if {$var(debug) == 0} {
        return
    } elseif {$var(debug) == 1} {
        tk_messageBox -title "Debug Info!" -icon info -message " $msg" -type ok
    } else {
        puts $msg
    }
}
proc Tablelist:GetRow {w x y } {
   
    set tablelist::x $x
    set tablelist::y $y
    set index [$w nearestcell $tablelist::x $tablelist::y]
    return $index
}
proc Tablelist:Colconf {w width l} {
  
    foreach el $l {
        lappend cols $width
        lappend cols $el
    }
    $w configure -columns $cols 
}
proc ComboBox:History:Add {w entryitem} {
  
}

proc LabelComboBox {f labeltext args} {
    frame $f
    pack [label $f.label -text "$labeltext"] -side left
    eval { ComboBox $f.combo } $args
    pack $f.combo -side left -expand yes -fill x
    lappend w $f
    lappend w $f.label
    lappend w $f.combo
    return $w
}
 
proc Text:LoadFile {w filename} {
    if [catch {open $filename r} infh] {
        tk_messageBox -title "Info!" -icon info -message "Cannot open $filename: $infh" -type ok
    } else {
        while {[gets $infh line] >= 0} {
            $w insert end "$line\n"
        }
        close $infh
    }
}

proc browser:findExecutable {progname varname} {
    upvar 1 $varname result
    set progs [auto_execok $progname]
    if {[llength $progs]} {
        set result [lindex $progs 0]
    }
    return [llength $progs]
}

proc browser:urlOpen {url} {
    global env tcl_platform
    switch $tcl_platform(platform) {
        "unix" {
            set browser ""
            set netscape  [auto_execok netscape]
            set mozilla   [auto_execok mozilla]
            set lynx      [auto_execok lynx]
            if {[info exists env(BROWSER)]} {
                set browser $env(BROWSER)
            } elseif {$netscape ne ""} {
                set browser $netscape
            } elseif {$mozilla ne ""} {
                set browser $mozilla
            } 
            if {$browser eq ""} {
                tk_messageBox -title "Info!" -icon info -message "No browser detected!" -type ok
            } else {
                # lynx can also output formatted text to a variable
                # with the -dump option, as a last resort:
                # set formatted_text [ exec lynx -dump $url ] - PSE
                if {[catch {exec $browser -remote $url}]} {
                    # perhaps browser doesn't understand -remote flag
                    if {[catch {exec $browser $url &} emsg]} {
                        error "Error displaying $url in browser\n$emsg"
                        # Another possibility is to just pop a window up
                        # with the URL to visit in it. - DKF
                    }
                }
            }
        }
        "windows" {
            if {$tcl_platform(os) == "Windows NT"} {
                set rc [catch {exec $env(COMSPEC) /c start $url &} emsg]
            } else {
               # Windows 95/98
               set rc [catch {exec start $url} emsg]
            }
            if {$rc} {
                error "Error displaying $url in browser\n$emsg"
            }
        }
        "macintosh" {
            if {0 == [info exists env(BROWSER)]} {
                set env(BROWSER) "Browse the Internet"
            }
            if {[catch {
                AppleScript execute\
                    "tell application \"$env(BROWSER)\"
                         open url \"$url\"
                     end tell
                "} emsg]
            } then {
                error "Error displaying $url in browser\n$emsg"
            }
        }
    } ;## end of switch
 }
