##############################################################################
#
#  			Copyright 2003 MPIMG Berlin, Germany.
#			      All Rights Reserved
#  Created By    : Dr. Detlef Groth nocatdgroth@molgen.mpg.de, nocatdetlef@dgroth.de
#                    delete nocat to answer
#  Created       : Mon Mar 10 16:41:10 2003
#  Last Modified : <040121.0914>
#
#  Description	A snit megawidgets
lappend auto_path [file join [file dirname [info script]] ..]
package provide dgwidgets 0.3
package require snit 0.91
package require BWidget


snit::widget mProgressBar {
    # progressbar with text
    variable lProgress
    variable pbProgress
    delegate option -variable to pbProgress
    delegate option -textvariable to lProgress
    constructor {args} {
        label $win.lPercent -text " % "
        label $win.lProgress 
        set lProgress $win.lProgress
        ProgressBar $win.pbProgress -height 20
        set pbProgress $win.pbProgress 
        pack $win.lProgress $win.lPercent $win.pbProgress -side left
        $self configurelist $args
    }
}
snit::widget mLabEntry {
    # a entry with label
    variable lab
    variable entry
    option -labelside left
    delegate option -labeltext to lab as -text
    delegate option * to entry
    constructor {args} {
        label $win.lbl
        set lab $win.lbl
        Entry $win.entry
        set entry $win.entry
        $self configurelist $args
        pack $win.lbl -side $options(-labelside)
        pack $win.entry -side $options(-labelside) -fill x -expand yes
      
    }
    
}
snit::widget mLabSpinBox {
    # spinbox with a label
    variable lab
    variable spin
    option -labelside left
    
    delegate option -labeltext to lab as -text
    delegate option -labelwidth to lab as -width
    delegate option * to spin
    constructor {args} {
        label $win.lb
        set lab $win.lb
        spinbox $win.spin
        set spin $win.spin
        $self configurelist $args
        pack $win.lb -side $options(-labelside)
        pack $win.spin -side $options(-labelside) -fill x -expand yes
    }
}


snit::widget mComboBox {
    # a combo box with a label
    # and a history method
    option -labelside left
    delegate option -labelwidth to label as -width
    delegate option -labeltext to label as -text
    delegate option * to combo
    expose combo
    expose label
    expose entry 
    #variable component
    constructor {args} {
        install label using label $win.lbl
        install combo using ComboBox $win.cb 
        #set component(combo) $win.cb
        #set component(label) $win.lbl
        #set component(entry) $win.cb.e
        set entry $win.cb.e
        $self configurelist $args
        pack $win.lbl -side $options(-labelside)
        pack $win.cb -side $options(-labelside) -fill x -expand yes
      
    }
    method addHistory {entryitem} {
        set vals [$combo cget -values] 
        set newvals {}
        foreach val $vals {
            catch {
                if {$val ne $entryitem} {
                    lappend newvals $val
                }
            }
        }
        $combo configure -values "{$entryitem} $newvals"
    }
    method component {w args} {
        if {[llength $args] == 0} {
            if {[info exists component($w)]} {
                return $component($w)
            } else {
                error "Component does not exist! Components are: [array names component]!"
            }
        } else {
            if {[info exists component($w)]} {
                if {[lindex $args 0] eq "bind"} {
                    eval { bind $component($w) } [lrange $args 1 end]
                } else {
                    eval { $component($w) } $args
                }
            } else {
                error "Component does not exist! Components are: [array names component]!"
            }
        }
    }
}
snit::widget SnitScrolledCanvas {
    variable can
    delegate option * to can
    delegate method * to can
    constructor {width height region args} {
        canvas $win.canvas -width $width -height $height \
              -xscrollcommand [list $win.xscroll set]  \
              -yscrollcommand [list $win.yscroll set] \
              -scrollregion $region
        set can $win.canvas
        scrollbar $win.yscroll -orient vertical -width 14\
                  -command [list $win.canvas yview]
        frame $win.bottom
        scrollbar $win.xscroll -orient horizontal -width 14 \
                  -command [list $win.canvas xview]
        set pad [expr [$win.yscroll cget -width] + 2* \
                 ([$win.yscroll cget -bd] + \
                  [$win.yscroll cget -highlightthickness])]
        frame $win.pad -width $pad -height $pad
        pack $win.bottom -side bottom -fill x
        pack $win.pad -in $win.bottom -side right
        pack $win.xscroll -in $win.bottom -side bottom -fill x
        pack $win.yscroll -side right -fill y
        pack $win.canvas  -side left -fill both -expand true
        $self configurelist $args
    }
    method getcanvas {} {
        return $can
    }
}



snit::widget SnitTablelist {
    typevariable checkedImg
    typevariable uncheckedImg
    delegate option * to tbl
    delegate method * to tbl
    constructor {args} {
        pack [ScrolledWindow $win.sw] -side top -expand yes -fill both
        pack [tablelist::tablelist $win.tl] -side top -fill both -expand 1
        set tbl $win.tl
        $win.sw setwidget $tbl
        
        $self configurelist $args  
    }
    typeconstructor {
        package require BWidget
        package require tablelist
        option add *Tablelist*Checkbutton.background		ivory
        option add *Tablelist*Checkbutton.activeBackground	ivory
        option add *Tablelist*Checkbutton.activeBackground	ivory
        option add *Tablelist*Entry.background			ivory
        option add *Tablelist.background	gray96
        option add *Tablelist.stripeBackground	#e0e8f0
        option add *Tablelist*selectBackground	gray50
        option add *Tablelist*selectForeground	white
        tablelist::addBWidgetEntry
        tablelist::addBWidgetSpinBox
        tablelist::addBWidgetComboBox
        set dir [file join $tablelist::library demos]
        #
        # Create two images, to be displayed in tablelist cells with boolean values
        #
        set ws [tk windowingsystem]
        set checkedImg   [image create bitmap ion -file [file join $dir .. images checked_${ws}.xbm]]
        set uncheckedImg [image create bitmap ioff -file [file join $dir .. images unchecked_${ws}.xbm]]
    }
    
}
