#  Object Name   : $RCSfile: imagewidgets.tcl,v $
#  Revision      : $Revision: 1.1.1.1 $
#  Date          : $Date: 2004/01/28 14:31:30 $
#  Author        : $Author: dgroth $
#  $Log: imagewidgets.tcl,v $
#  Revision 1.1.1.1  2004/01/28 14:31:30  dgroth
#  initial import into cvs
#
#
##############################################################################
lappend auto_path ../dgapps/dgTools.vfs/lib

package require snit
package require BWidget
package require dgwidgets
snit::widget SnitScrolledImage {
    variable can
    delegate option * to can
    delegate method * to can
    option -imagecmd
    variable first false
    constructor {width height region args} {
        pack [SnitScrolledCanvas $win.canvas $width $height $region] -side top -fill both -expand yes
        set can $win.canvas
        $self configurelist $args
    }
    
    method showImage {image} {
        $can configure -width [image width $image]
        $can configure -height [image height $image]
        $can configure -scrollregion [list 0 0 [image width $image] [image height $image]]
        if {!$first} {
            $can create image 0 0 -anchor nw -image $image
            set first true
        }
        if {$options(-imagecmd) ne ""} {
            $options(-imagecmd)
        }
    }
}
snit::widget SnitImageWithToolBar {
    variable ilist
    variable can
    variable lastdir "null"
    variable lastfile ""
    variable filter *.jpg
    variable ifilename
    variable imagetool
    variable magnify 1
    variable flipX 1
    variable flipY 1
   variable rotate 0
    variable idx 0 ;# index of current image
    option -imagecmd ""
    delegate option * to can
    delegate method * to can
    constructor {args} {
        
        pack [frame $win.f1] -side top -fill x -expand no
        pack [button $win.f1.start -image playstart -command [mymethod _ChangeIndex 0] -state disabled] -side left
        pack [button $win.f1.left -image leftarrow -command [mymethod _ChangeIndex -1] -state disabled] -side left  
        pack [button $win.f1.right -image rightarrow -command [mymethod _ChangeIndex +1] -state disabled] -side left    
        pack [button $win.f1.end -image playend  -command [mymethod _ChangeIndex end] -state disabled] -side left    
        pack [frame $win.f1.f0 -width 10] -side left
        pack [button $win.f1.magminus -image viewmag- -command [mymethod _ChangeMag 0.5]] -side left
        pack [button $win.f1.magnormal -image viewmag -command [mymethod _ChangeMag 1]] -side left
        pack [button $win.f1.magplus -image viewmag+ -command [mymethod _ChangeMag 2]] -side left
        pack [frame $win.f1.f1 -width 10] -side left
        pack [button $win.f1.flipLR -image redo -command [mymethod _ToggleFlip LR]] -side left
        pack [button $win.f1.flipTB -image updown -command [mymethod _ToggleFlip TB]] -side left
        #pack [button $win.f1.rotateL -text " L " -command [mymethod _Rotate L]] -side left
        pack [frame $win.f1.f2 -width 10] -side left
        pack [ComboBox $win.f1.filename -textvariable [varname ifilename] -editable true \
              -modifycmd [mymethod _Combo_LoadImage] -autocomplete true \
              -command [mymethod _Combo_LoadImage]] -side left -expand yes -fill x -padx 5
        pack [mComboBox $win.f1.filter -labeltext Filter: -width 30 -textvariable [varname filter] \
              -editable true -modifycmd [mymethod _Filter_Update] -command [mymethod _Filter_Update] \
              ] -side left -expand no -fill x -padx 5
        pack [frame $win.f2] -side top -fill both -expand yes
     
        pack [SnitScrolledImage $win.f2.canvas 400 300 {0 0 400 300}] -side top -fill both -expand yes
        set can $win.f2.canvas
        set imagetool [imagetool imgtool]
        $self configurelist $args
    }
    method _Rotate {which} {
        if {$which eq "L"} {
            incr rotate 90
        } else {
            incr rotate -90
        }
        if {$rotate == 360} {
            set rotate 0
        }
    }
    method _ToggleFlip {which} {
        if {$which eq "LR"} {
            if {$flipX eq 1} { set flipX -1 } else { set flipX 1 }
        } else {
            if {$flipY eq 1} { set flipY -1 } else { set flipY 1 }
        }
        $self _LoadImage $idx
    }
    method _ChangeMag {value} {
        if {$value == 1} {
            set magnify 1
        } elseif {$value < 1} {
            set magnify [expr $magnify / 2.0]
        } else {
            set magnify [expr $magnify * 2.0]
        }
        if {$magnify == 1} {
            $win.f1.magplus configure -state normal
            $win.f1.magminus configure -state normal
            $win.f1.magnormal configure -state disabled
        } elseif {$magnify > 4} {
            $win.f1.magplus configure -state disabled
            $win.f1.magminus configure -state normal
            $win.f1.magnormal configure -state normal
        }  elseif {$magnify < 0.125} {
            $win.f1.magplus configure -state normal
            $win.f1.magminus configure -state disabled
            $win.f1.magnormal configure -state normal
        }
        $self _LoadImage $idx
    
    }
    method getFilename {} {
        return $ifilename
    }
    method _Combo_LoadImage {} {
        if {[file exists $ifilename]} {
            set index [lsearch -exact $ilist $ifilename]
            $self _LoadImage $index
        }
    }
    method _Filter_Update {} {
        set ilist [list]
        $self _RecurseDir $lastdir
        set ifilename [lindex $ilist 0]
        $win.f1.filename configure -values $ilist
        $self _LoadImage 0
        $win.f1.filter addHistory $filter
    }
    method _UpdateButtons {index} {
        set length [llength $ilist]
        if {$index == [expr $length - 1]} {
            $win.f1.end configure -state disabled
            $win.f1.right configure -state disabled
            $win.f1.left configure -state normal
            $win.f1.start configure -state normal
        } elseif {$index == 0} {
            $win.f1.end configure -state normal
            $win.f1.right configure -state normal
            $win.f1.left configure -state disabled
            $win.f1.start configure -state disabled
        } else {
            $win.f1.end configure -state normal
            $win.f1.right configure -state normal
            $win.f1.left configure -state normal
            $win.f1.start configure -state normal
        }
    }
    method _RecurseDir {dir} {
        foreach file [glob -nocomplain $dir/$filter] {
            lappend ilist $file
        }
        set dirs [glob -nocomplain -types d $dir/*]
        foreach mdir $dirs {
            $self _RecurseDir $mdir
        }
    }
    method loadDir {dir} {
        if {$lastdir ne $dir && [string first $lastdir $dir] < 0} {
            set ilist [list]
            # sets global var ilist again to files recursivly inside dir
            $self _RecurseDir $dir 
            #set ilist [glob -nocomplain $dir/$filter]
            $win.f1.filename configure -values $ilist
            set lastdir $dir
        }
        $self _LoadImage 0
    }
    method showImage {filename} {
        if {![file exists $filename]} { return }
        #tk_messageBox -title "Info!" -icon info -message "$options(-imagecmd) showImage $filename lastfile is $lastfile..." -type ok
        set ifilename $filename
        if {$lastdir ne [file dirname $filename] && [string first $lastdir [file dirname $filename]] < 0} {
            loadDir $dir
        }
        image create photo Photo -file $filename
        # check magnification
        if {$magnify != 10} {
            imgtool scaleImage Photo $magnify
        }
        if {$flipX != 1 || $flipY ne 1} {
            imgtool scaleImage Photo $flipX $flipY
        }
        #        if {$rotate != 0} {
        #            set img [imgtool canvas2Photo [$can getcanvas]]
        #            set img [imgtool rotateimg $img $rotate]
        #            $can showImage $img
        #        } 
        $can showImage Photo
        if {$options(-imagecmd) ne "" && $lastfile ne $filename} {
            #tk_messageBox -title "Info!" -icon info -message "Execute: $options(-imagecmd) ." -type ok
            $options(-imagecmd)
            set lastfile $filename
        }
        
    }
    method _ChangeIndex {index} {
        if {$index == 0} {
            set idx 0
        } elseif {$index eq "end"} {
            set idx [expr [llength $ilist] -1]
        } else {
            incr idx $index
        }
        $self _LoadImage $idx
    }
    method _LoadImage {index} {
        set idx $index
        $self showImage [lindex $ilist $idx]
        $self _UpdateButtons $idx
    }
}
proc Test {} {
    package require Img   
    source images.tcl
    source imagetool.tcl
  
    pack [SnitImageWithToolBar .tl] -side top -fill both -expand yes
    .tl loadDir d:/home/dgroth/bild
}
#Test
