# popupnotebook.tcl --
#
#       Snit BWidget Popup NoteBook
#
# Copyright (c) 2003    Dr. Detlef Groth <dgroth@gmx.de>
#
# See the file "license.terms" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.
# 
# RCS: @(#) $Id: popupnotebook.tcl,v 0.1 2003/11/30 18:26:59 detlef_groth Exp $
# Last Modified : <031130.0656>

snit::widget PopupNoteBook {
    option -addpagecmd
    option -raisecmd
    typevariable px
    typeconstructor {
        set px 1
    }
    constructor {args} {
        pack [NoteBook $win.nb -side top -width 150 -height 50] -fill both -expand yes -side top
        $win.nb bindtabs <ButtonPress-3> [mymethod _NBPopup]
        $self configurelist $args
       
    }
    method _NBDeletePage {page rpage} {
        $win.nb delete $page
        $win.nb raise $rpage
    }
    method pageadd {} {
        $self _NBAddPage
    }
    method pagesget {} {
        set liste [list]
        foreach page [$win.nb pages] {
            lappend liste [$win.nb itemcget $page -text]
        }
        return $liste
    }
    method _NBAddPage {} {
        $win.nb insert end page$px -text " $px " 
        if {[info exists options(-raisecmd)]} {
            $win.nb itemconfigure page$px -raisecmd $options(-raisecmd)
        }
        set f [$win.nb getframe page$px]
     
        $win.nb raise page$px
      
        incr px
        return $f
            
    }
    method _NBPopup {page} {
        if {[winfo exists .tmenu]} {destroy .tmenu}
        menu .tmenu -tearoff 0
        .tmenu add command -label "New Tab" -command [list $self _NBAddPage]
        set endIndex [llength [$win.nb pages]]
        set curIndex [$win.nb index $page]
        if { $endIndex > 1} {
            set idx $curIndex
            incr idx -1
            set rpage [$win.nb pages $idx]
            .tmenu add command -label "Delete Tab" -command [list $self _NBDeletePage $page $rpage]
            # does not work
        }
        incr endIndex -1
        if { $curIndex > 0} {
            set newIndex $curIndex
            incr newIndex -1
            .tmenu add command -label "switch left" -command [list $win.nb move $page $newIndex]
        }
        
        if { $curIndex < $endIndex } {
            set newIndex $curIndex
            incr newIndex 1
            .tmenu add command -label "switch right" -command [list $win.nb move $page $newIndex]
        }
        .tmenu add separator
        .tmenu add command -label "rename tab" -command [list $self _NBTabRename]
        set x [winfo pointerx .]
        set y [winfo pointery .]
        tk_popup .tmenu $x $y 
        return
    }
    method _NBTabRenameOK {} {
        $win.nb itemconfigure [$win.nb raise] -text $pagename
        destroy .tabrename
    }
    method _NBTabRename {} {
        catch {destroy .tabrename}
        set x [winfo pointerx .]
        set y [winfo pointery .]
        toplevel .tabrename 
        wm geometry .tabrename +$x+$y
        wm title .tabrename "Rename Tab"
        set pagename [$win.nb itemcget [$win.nb raise] -text]
       
        pack [entry .tabrename.entry -textvariable [varname pagename]] -side left -padx 5 -pady 5
        pack [button .tabrename.ok -text OK -width 10 -command [list $self _NBTabRenameOK]] -side left -padx 5 -pady 5
        pack [button .tabrename.cancel -text Cancel -width 10 -command [list destroy .tabrename]] -side left -padx 5 -pady 5
    }
    
}