#By Eric Foster-Johnson
# wrapped into a snit widget by Dr. Detlef Groth 2003
#Found in his book Graphical Applications with Tcl and Tk (2nd ed)
#http://www.pconline.com/~erc/tclbook.htm
snit::widget splash {
    hulltype toplevel 
    
    option -image ""
    option -product ""
    option -copyright ""
    option -msg ""
    constructor {args} {
        global tcl_version tk_version tcl_platform
        global tcl_patchLevel
    
        wm withdraw .
        wm withdraw $win
	wm overrideredirect $win 1
        # Center on screen.
       
	
        # Top area contains product info.
        set frm $win.top
        frame $frm -bd 2 -relief groove
        $self configurelist $args
        dialog_position $win
        $hull configure -borderwidth 0
        $hull configure -cursor watch
       
        image create photo splash -file "$options(-image)"
        # Label for logo image
        label $frm.logo -image splash
        
        # Label for product version number.
        label $frm.product -text "$options(-product)"
        
        # Message widget for copyright info.
        message $frm.copyright -text "$options(-copyright)" -width 3i
        
        # Label for Tcl version number.
        label $frm.tclversion -text \
                  "Tcl $tcl_version/Tk $tk_version, $tcl_patchLevel"
        
        # Label for OS version.
        label $frm.osversion -text \
                  "$tcl_platform(os) $tcl_platform(osVersion)"
        
        pack $frm.logo \
                  -side top -fill x -pady 4 -ipadx 4 -ipady 4
        
        pack $frm.product $frm.copyright \
                  $frm.tclversion $frm.osversion \
                  -side top -fill x 
        
        pack $frm -side top -fill x -padx 8 -pady 8
        
        # Bottom area contains current message
        set frm $win.bottom
        frame $frm -bd 2 -relief groove
        
        # Label for message
        label $frm.msg -text "$options(-msg)" -anchor w
        
        pack $frm.msg -side left -ipadx 6 -ipady 4
        pack $frm -side bottom -fill x -padx 8 -pady 8
        
        wm deiconify $win
        update
        after 1500
    }
    proc dialog_position { dlg } {

        set width  [winfo screenwidth  . ]
        set height [winfo screenheight . ]

        set x [expr ($width/2)  - 260]
        set y [expr ($height/2) - 260]

        wm geometry $dlg +$x+$y

    }
    # Updates text message in splash screen dialog.
    method update { msg } {
        set name $win.bottom.msg
        
        if { [winfo exists $name] } {
            $name configure -text "$msg"
            update
        }
        
    }
    
    

    # Removes splash screen dialog.
    method remove { } {
        splash_window_center .
        wm deiconify .
        update 
        after 1500 
        if { [winfo exists $win] } {
            $hull configure -cursor ""
            destroy $win
        }
    }
    # dgroth add to center a larger window
    proc splash_window_center { win {winwidth 700} {winheight 500}} {
        set width  [winfo screenwidth  . ]
        set height [winfo screenheight . ]
        
        set x [expr ($width/2)  - ($winwidth/2)]
        set y [expr ($height/2) - ($winheight/2)]
        
        wm geometry $win ${winwidth}x${winheight}+$x+$y
        
    }

}
